package com.fujitsu.test.ejb3.client ;

import javax.naming.*;
import java.util.*;
import javax.rmi.*;
import com.fujitsu.test.ejb3.remote.*;

/**
* Application Class
*
* @author
* @version
*/
public class TestClient {
	FirstHome home=null;
	FirstRemote remote=null;
	static String cl_sleep_time = "0" ;
	static String sv_sleep_time = "0" ;
	static int sleep_time = 0 ;

	public static void main(String[] args) {

		if( args.length > 0 ) {

			for( int i=0 ; i<args.length ;i++ ) {

				if( args[i].equals( "-c" ) ){
					if( i == args.length ) {
						System.out.println( "Please set client sleep time." ) ;
						System.exit(-1) ;
					} else {
						cl_sleep_time = args[i+1] ;
						i++ ;
					}
				} else if( args[i].equals( "-s" ) ){
					if( i == args.length ) {
						System.out.println( "Please set client sleep time." ) ;
						System.exit(-1) ;
					} else {
						sv_sleep_time = args[i+1] ;
						i++ ;
					}
				}

				sleep_time = Integer.parseInt(cl_sleep_time) ;
			}
		}

		try {
			TestClient client = new TestClient() ;
			client.test() ;
		} catch( Exception e ) {
			e.printStackTrace() ;
		}
	}

	// Constructor
	public TestClient() throws NamingException {
		javax.naming.Context initialContext = null;
		System.out.println( "START : InitialContext new" ) ;
		initialContext = new InitialContext();
		System.out.println( "END   : InitialContext new" ) ;
		System.out.println( "START : lookup" ) ;
		Object obj = initialContext.lookup("java:comp/env/ejb/FirstBean");
		home = (FirstHome)PortableRemoteObject.narrow(obj,FirstHome.class);
		System.out.println( "END   : lookup" ) ;
	}


	public String test() {

		String result = "" ;
		Hashtable env = new Hashtable() ;
		env.put( "com.server.leep.time" , sv_sleep_time ) ;

		try {
			System.out.println( "sleep time(ms):" + sleep_time ) ;
			Thread.sleep( sleep_time ) ;
			System.out.println( "START : invoke" ) ;
			remote = home.create() ;
			remote.call(env) ;
			remote.remove() ;
			System.out.println( "END   : invoke : " + result ) ;
		} catch( Exception e ) {
			System.out.println( "EXCEPTION:"+e.toString()) ;
			e.printStackTrace() ;
		}
		return(result) ;
	}

}
