package com.fujitsu.test.ejb3 ;

import javax.ejb.EJB ;
import javax.ejb.Stateless ;
import javax.ejb.Remove ;
import javax.ejb.EJBException ;
import java.util.Hashtable ;
import com.fujitsu.test.ejb3.local.* ;
import com.fujitsu.test.ejb3.remote.* ;
import javax.ejb.* ;
import java.sql.* ;
import javax.sql.* ;
import javax.naming.* ;

public class FirstBean implements SessionBean {
	SecondLocalHome secondHome ;
	SecondLocal second ;
	DataSource ds ;

	public FirstBean() {
	}

    /**
     * Sets the session context. Required by EJB spec.
     * @param sc A SessionContext object.
     */
	public void setSessionContext(SessionContext sc) {

		try {
			InitialContext ic = new InitialContext() ;
			secondHome = (SecondLocalHome)ic.lookup( "java:comp/env/ejb/SecondLocal" ) ;
			ds = (DataSource)ic.lookup( "java:comp/env/jdbc/TestDS" ) ;
		} catch( Exception e ) {
			e.printStackTrace() ;
			throw new EJBException( e.toString() ) ;
		}

	}

	public void ejbCreate() throws javax.ejb.CreateException {
	}

	// business method
	public void call(Hashtable option) {
		System.out.println( "first called" ) ;
		try {
			Connection con = ds.getConnection() ;
			second = secondHome.create() ;
			second.call(null) ;
			second.remove() ;
			con.close() ;
		} catch( Exception e ) {
			e.printStackTrace() ;
			throw new EJBException(e.toString()) ;
		}
		return ;
	}
    /**
     * Removes the bean. Required by EJB spec.
     */
	public void ejbRemove() {}

    /**
     * Loads the state of the bean from secondary storage. Required by EJB spec.
     */
	public void ejbActivate() {}

    /**
     * Keeps the state of the bean to secondary storage. Required by EJB spec.
     */
	public void ejbPassivate() {}

}
